//+------------------------------------------------------------------+
//|                                                 PipeTrader 20pip |
//|                                                www.forex-tsd.com |
//|                                                            mikep |
//+------------------------------------------------------------------+

#property copyright "System by PipeTrader, programmed by mikep"


#define MIN_STOPLOSS_POINT 10
#define MIN_TAKEPROFIT_POINT 10 
#define MAGIC 420292

extern string ExpertName = "20p Only";
extern int nAccount = 0;
extern double StopLoss = 50;
extern double TakeProfit = 20;
extern double TrailingStop = 10;
extern double Lots = 0.10; 
extern int Slippage = 3;
extern bool UseHourTrade = False;
extern int FromHourTrade = 0;
extern int ToHourTrade = 23;
extern bool FlagUseSound = False;
extern string SoundFileName = "alert.wav";
extern color colorOpenBuy = Blue;
extern color colorCloseBuy = Aqua;
extern color colorOpenSell = Red;
extern color colorCloseSell = Aqua;
extern double ForceSellThreshold = -0.03;
extern double ForceBuyThreshold = 0.03;


void deinit() {
   Comment("");
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start(){
   if (UseHourTrade){
      if (!(Hour()>=FromHourTrade && Hour()<=ToHourTrade)) {
         Comment("Time for trade has not come else!");
         return(0);
      }
   }
   
   if(Bars < 100){
      Print("bars less than 100");
      return(0);
   }
   
   if (nAccount > 0 && nAccount != AccountNumber()){
      Comment("Trade on account :"+AccountNumber()+" FORBIDDEN!");
      return(0);
   }
   
   if((StopLoss > 0 && StopLoss < MIN_STOPLOSS_POINT) ||
      (StopLoss > 0 && StopLoss < MIN_STOPLOSS_POINT)){
      Print("StopLoss less than " + MIN_STOPLOSS_POINT);
      return(0);
   }
   if((TakeProfit > 0 && TakeProfit < MIN_TAKEPROFIT_POINT) ||
      (TakeProfit > 0 && TakeProfit < MIN_TAKEPROFIT_POINT)){
      Print("TakeProfit less than " + MIN_TAKEPROFIT_POINT);
      return(0);
   }

double StepMAUp11=iCustom(NULL,Period(),"N_StepMA_1_Email",7,0.75,0,5000,false,0,1);
double StepMAUp12=iCustom(NULL,Period(),"N_StepMA_1_Email",7,0.75,0,5000,false,0,2);
double StepMAUp13=iCustom(NULL,Period(),"N_StepMA_1_Email",7,0.75,0,5000,false,0,3);
double StepMADown21=iCustom(NULL,Period(),"N_StepMA_1_Email",7,0.75,0,5000,false,1,1);
double StepMADown22=iCustom(NULL,Period(),"N_StepMA_1_Email",7,0.75,0,5000,false,1,2);
double StepMADown23=iCustom(NULL,Period(),"N_StepMA_1_Email",7,0.75,0,5000,false,1,3);
double Force1=iForce(NULL,30,13,MODE_SMA,PRICE_CLOSE,1);
double Force2=iForce(NULL,30,13,MODE_SMA,PRICE_CLOSE,2);
double Force3=iForce(NULL,30,13,MODE_SMA,PRICE_CLOSE,3);

   if(AccountFreeMargin() < (1000*Lots)){
      Print("We have no money. Free Margin = " + AccountFreeMargin());
      return(0);
   }
   
   bool lFlagBuyOpen = false, lFlagSellOpen = false, lFlagBuyClose = false, lFlagSellClose = false;
   
  
   lFlagBuyOpen = (StepMAUp12<=StepMADown22 && StepMAUp11>StepMADown21 && Force1>ForceBuyThreshold) || (StepMAUp13<=StepMADown23 && StepMAUp12>StepMADown22 && StepMAUp11>StepMADown21 && Force2<ForceBuyThreshold && Force1>ForceBuyThreshold) || (StepMAUp11>StepMADown21 && Force3<=ForceBuyThreshold && Force2>ForceBuyThreshold && Force1>ForceBuyThreshold);
   lFlagSellOpen = (StepMAUp12>=StepMADown22 && StepMAUp11<StepMADown21 && Force1<ForceSellThreshold) || (StepMAUp13>=StepMADown23 && StepMAUp12<StepMADown22 && StepMAUp11<StepMADown21 && Force2>ForceSellThreshold && Force1<ForceSellThreshold) || (StepMAUp11<StepMADown21 && Force3>=ForceSellThreshold && Force2<ForceSellThreshold && Force1<ForceSellThreshold);
   lFlagBuyClose = (StepMAUp12>=StepMADown22 && StepMAUp11<StepMADown21);
   lFlagSellClose = (StepMAUp12<=StepMADown22 && StepMAUp11>StepMADown21);
   
   if (!ExistPositions()){

      if (lFlagBuyOpen){
         OpenBuy();
         return(0);
      }

      if (lFlagSellOpen){
         OpenSell();
         return(0);
      }
   }
   if (ExistPositions()){
      if(OrderType()==OP_BUY){
         if (lFlagBuyClose){
            bool flagCloseBuy = OrderClose(OrderTicket(), OrderLots(), Bid, Slippage, colorCloseBuy); 
            if (flagCloseBuy && FlagUseSound) 
               PlaySound(SoundFileName); 
            return(0);
         }
      }
      if(OrderType()==OP_SELL){
         if (lFlagSellClose){
            bool flagCloseSell = OrderClose(OrderTicket(), OrderLots(), Ask, Slippage, colorCloseSell); 
            if (flagCloseSell && FlagUseSound) 
               PlaySound(SoundFileName); 
            return(0);
         }
      }
   }
   
   if (TrailingStop > 0 || TrailingStop > 0){
      
      for (int i=0; i<OrdersTotal(); i++) { 
         if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) { 
            bool lMagic = true;
            if (MAGIC > 0 && OrderMagicNumber() != MAGIC)
               lMagic = false;
            
            if (OrderSymbol()==Symbol() && lMagic) { 
               if (OrderType()==OP_BUY && TrailingStop > 0) { 
                  if (Bid-OrderOpenPrice() > TrailingStop*Point) { 
                     if (OrderStopLoss()<Bid-TrailingStop*Point) 
                        ModifyStopLoss(Bid-TrailingStop*Point); 
                  } 
               } 
               if (OrderType()==OP_SELL) { 
                  if (OrderOpenPrice()-Ask>TrailingStop*Point) { 
                     if (OrderStopLoss()>Ask+TrailingStop*Point || OrderStopLoss()==0)  
                        ModifyStopLoss(Ask+TrailingStop*Point); 
                  } 
               } 
            } 
         } 
      } 
   }
   return (0);
}

bool ExistPositions() {
	for (int i=0; i<OrdersTotal(); i++) {
		if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
         bool lMagic = true;
         
         if (MAGIC > 0 && OrderMagicNumber() != MAGIC)
            lMagic = false;

			if (OrderSymbol()==Symbol() && lMagic) {
				return(True);
			}
		} 
	} 
	return(false);
}

void ModifyStopLoss(double ldStopLoss) { 
   bool lFlagModify = OrderModify(OrderTicket(), OrderOpenPrice(), ldStopLoss, OrderTakeProfit(), 0, CLR_NONE); 
   if (lFlagModify && FlagUseSound) 
      PlaySound(SoundFileName); 
} 

void OpenBuy() { 
   double dStopLoss = 0, dTakeProfit = 0;

   if (StopLoss > 0)
      dStopLoss = Ask-StopLoss*Point;
   
   if (TakeProfit > 0)
     dTakeProfit = Ask + TakeProfit * Point; 
   
   int numorder = OrderSend(Symbol(), OP_BUY, Lots, Ask, Slippage, dStopLoss, dTakeProfit, ExpertName, MAGIC, 0, colorOpenBuy); 
   
   if (numorder > -1 && FlagUseSound) 
      PlaySound(SoundFileName);
} 

void OpenSell() { 
   double dStopLoss = 0, dTakeProfit = 0;
   
   if (StopLoss > 0)
      dStopLoss = Bid+TakeProfit*Point;
   
   if (TakeProfit > 0)
      dTakeProfit = Bid-TakeProfit*Point;
   
   int numorder = OrderSend(Symbol(),OP_SELL, Lots, Bid, Slippage, dStopLoss, dTakeProfit, ExpertName, MAGIC, 0, colorOpenSell); 
   
   if (numorder > -1 && FlagUseSound) 
      PlaySound(SoundFileName); 
} 

